// Code generated by easyjson for marshaling/unmarshaling. DO NOT EDIT.

package xls2json

import (
	json "encoding/json"
	easyjson "github.com/mailru/easyjson"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
)

// suppress unused package warning
var (
	_ *json.RawMessage
	_ *jlexer.Lexer
	_ *jwriter.Writer
	_ easyjson.Marshaler
)

func easyjsonA32c74f9DecodeXls2json(in *jlexer.Lexer, out *tableArray) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		in.Skip()
		*out = nil
	} else {
		in.Delim('[')
		if *out == nil {
			if !in.IsDelim(']') {
				*out = make(tableArray, 0, 2)
			} else {
				*out = tableArray{}
			}
		} else {
			*out = (*out)[:0]
		}
		for !in.IsDelim(']') {
			var v1 []string
			if in.IsNull() {
				in.Skip()
				v1 = nil
			} else {
				in.Delim('[')
				if v1 == nil {
					if !in.IsDelim(']') {
						v1 = make([]string, 0, 4)
					} else {
						v1 = []string{}
					}
				} else {
					v1 = (v1)[:0]
				}
				for !in.IsDelim(']') {
					var v2 string
					v2 = string(in.String())
					v1 = append(v1, v2)
					in.WantComma()
				}
				in.Delim(']')
			}
			*out = append(*out, v1)
			in.WantComma()
		}
		in.Delim(']')
	}
	if isTopLevel {
		in.Consumed()
	}
}
func easyjsonA32c74f9EncodeXls2json(out *jwriter.Writer, in tableArray) {
	if in == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
		out.RawString("null")
	} else {
		out.RawByte('[')
		for v3, v4 := range in {
			if v3 > 0 {
				out.RawByte(',')
			}
			if v4 == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
				out.RawString("null")
			} else {
				out.RawByte('[')
				for v5, v6 := range v4 {
					if v5 > 0 {
						out.RawByte(',')
					}
					out.String(string(v6))
				}
				out.RawByte(']')
			}
		}
		out.RawByte(']')
	}
}

// MarshalJSON supports json.Marshaler interface
func (v tableArray) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjsonA32c74f9EncodeXls2json(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v tableArray) MarshalEasyJSON(w *jwriter.Writer) {
	easyjsonA32c74f9EncodeXls2json(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *tableArray) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjsonA32c74f9DecodeXls2json(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *tableArray) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjsonA32c74f9DecodeXls2json(l, v)
}
